OpenVDB 7.0.0

Public Types | Public Member Functions | Static Public Attributes | List of all members
IterListItem< PrevItemT, NodeVecT, 1, _Level > Class Template Reference

The final element of a compile-time linked list of iterators to nodes of different types. More...

`#include <TreeIterator.h>`

## Public Types
using | _NodeT = typename boost::mpl::front< NodeVecT >::type
using | PrevIterT = typename PrevItemT::IterT
| The type of iterator stored in the previous list item. More...
using | IterT = typename IterTraits< typename PrevIterT::NonConstNodeType, PrevIterT >::template NodeConverter< _NodeT >::Type
| The type of iterator stored in this list item (e.g., RootNode::ValueOnCIter) More...
using | NodeT = typename IterT::NodeType
| The type of node over which IterT iterates (e.g., const RootNode<...>) More...
using | NCNodeT = typename IterT::NonConstNodeType
| The type of the node with const qualifiers removed ("Non-Const") More...
using | NCValueT = typename IterT::NonConstValueType
| The type of value (with const qualifiers removed) to which the iterator points. More...
using | ChildT = typename CopyConstness< NodeT, typename NodeT::ChildNodeType >::Type
| NodeT's child node type, with the same constness (e.g., const InternalNode<...>) More...
using | NCChildT = typename CopyConstness< NCNodeT, typename NCNodeT::ChildNodeType >::Type
| NodeT's child node type with const qualifiers removed. More...
using | ITraits = IterTraits< NCNodeT, IterT >

## Public Member Functions
| IterListItem (PrevItemT *prev)
| IterListItem (const IterListItem &other)
IterListItem & | operator= (const IterListItem &other)
void | updateBackPointers (PrevItemT *prev)
void | setIter (const IterT &iter)
void | getNode (Index lvl, NodeT *&node) const
template<typename OtherIterListItemT >
void | initLevel (Index lvl, OtherIterListItemT &otherListItem)
Index | pos (Index lvl) const
bool | test (Index lvl) const
bool | next (Index lvl)
bool | down (Index lvl)
Coord | getCoord (Index lvl) const
Index | getChildDim (Index lvl) const
Index64 | getVoxelCount (Index lvl) const
bool | isValueOn (Index lvl) const
const NCValueT & | getValue (Index lvl) const
void | setValue (Index lvl, const NCValueT &val) const
void | setValueOn (Index lvl, bool on=true) const
void | setValueOff (Index lvl) const
template<typename ModifyOp >
void | modifyValue (Index lvl, const ModifyOp &op) const

## Static Public Attributes
static const Index | Level = _Level
| NodeT's level in its tree (0 = LeafNode) More...

## Detailed Description

### template<typename PrevItemT, typename NodeVecT, Index _Level>
class openvdb::v7_0::tree::IterListItem< PrevItemT, NodeVecT, 1, _Level >

The final element of a compile-time linked list of iterators to nodes of different types.

## Member Typedef Documentation

## ◆ _NodeT

using _NodeT = typename boost::mpl::front<NodeVecT>::type

## ◆ ChildT

using ChildT = typename CopyConstness<NodeT, typename NodeT::ChildNodeType>::Type

NodeT's child node type, with the same constness (e.g., const InternalNode<...>)

## ◆ IterT

using IterT = typename IterTraits<typename PrevIterT::NonConstNodeType, PrevIterT>::template NodeConverter<_NodeT>::Type

The type of iterator stored in this list item (e.g., RootNode::ValueOnCIter)

## ◆ ITraits

using ITraits = IterTraits<NCNodeT, IterT>

## ◆ NCChildT

using NCChildT = typename CopyConstness<NCNodeT, typename NCNodeT::ChildNodeType>::Type

NodeT's child node type with const qualifiers removed.

## ◆ NCNodeT

using NCNodeT = typename IterT::NonConstNodeType

The type of the node with const qualifiers removed ("Non-Const")

## ◆ NCValueT

using NCValueT = typename IterT::NonConstValueType

The type of value (with const qualifiers removed) to which the iterator points.

## ◆ NodeT

using NodeT = typename IterT::NodeType

The type of node over which IterT iterates (e.g., const RootNode<...>)

## ◆ PrevIterT

using PrevIterT = typename PrevItemT::IterT

The type of iterator stored in the previous list item.

## Constructor & Destructor Documentation

## ◆ IterListItem() [1/2]

IterListItem | ( | PrevItemT * | prev | ) |
| inline

## ◆ IterListItem() [2/2]

IterListItem | ( | const IterListItem< PrevItemT, NodeVecT, 1, _Level > & | other | ) |
| inline

## Member Function Documentation

## ◆ down()

bool down | ( | Index | lvl | ) |
| inline

## ◆ getChildDim()

Index getChildDim | ( | Index | lvl | ) | const
| inline

## ◆ getCoord()

Coord getCoord | ( | Index | lvl | ) | const
| inline

## ◆ getNode()

void getNode | ( | Index | lvl,
|  | NodeT *& | node
| ) |  | const
| inline

## ◆ getValue()

const NCValueT& getValue | ( | Index | lvl | ) | const
| inline

## ◆ getVoxelCount()

Index64 getVoxelCount | ( | Index | lvl | ) | const
| inline

## ◆ initLevel()

void initLevel | ( | Index | lvl,
|  | OtherIterListItemT & | otherListItem
| ) |  |
| inline

## ◆ isValueOn()

bool isValueOn | ( | Index | lvl | ) | const
| inline

## ◆ modifyValue()

void modifyValue | ( | Index | lvl,
|  | const ModifyOp & | op
| ) |  | const
| inline

## ◆ next()

bool next | ( | Index | lvl | ) |
| inline

## ◆ operator=()

IterListItem& operator= | ( | const IterListItem< PrevItemT, NodeVecT, 1, _Level > & | other | ) |
| inline

## ◆ pos()

Index pos | ( | Index | lvl | ) | const
| inline

## ◆ setIter()

void setIter | ( | const IterT & | iter | ) |
| inline

## ◆ setValue()

void setValue | ( | Index | lvl,
|  | const NCValueT & | val
| ) |  | const
| inline

## ◆ setValueOff()

void setValueOff | ( | Index | lvl | ) | const
| inline

## ◆ setValueOn()

void setValueOn | ( | Index | lvl,
|  | bool | on = `true`
| ) |  | const
| inline

## ◆ test()

bool test | ( | Index | lvl | ) | const
| inline

## ◆ updateBackPointers()

void updateBackPointers | ( | PrevItemT * | prev | ) |
| inline

## Member Data Documentation

## ◆ Level

const Index Level = _Level
| static

NodeT's level in its tree (0 = LeafNode)

The documentation for this class was generated from the following file:

- TreeIterator.h